use strict;
use warnings;
use Glib qw(TRUE FALSE);
use Gtk2 qw/-init/;
use Data::Dumper;

my $TEXT_COLUMN   = 0;
my $PIXBUF_COLUMN = 1;

my $iconview = make_iconview();
for (1..10) {
	add_to_iconview($iconview, 'h'.$_);
}

my $window = Gtk2::Window->new;
$window->signal_connect('destroy', sub {Gtk2->main_quit;});

my $vbox = Gtk2::VBox->new (FALSE, 0);

my $label1 = Gtk2::Label->new('One');
$label1->modify_font(Gtk2::Pango::FontDescription->from_string("Sans Bold 48"));

my $label2 = Gtk2::Label->new('Two');
$label2->modify_font(Gtk2::Pango::FontDescription->from_string("Sans Bold 48"));

$vbox->pack_start ($label1, FALSE, FALSE, 0);
$vbox->pack_start ($iconview, TRUE, TRUE, 0);
$vbox->pack_start ($label2, FALSE, FALSE, 0);

my $scrolledwindow = Gtk2::ScrolledWindow->new;
$scrolledwindow->add_with_viewport($vbox);
$scrolledwindow->set_policy('automatic', 'automatic');

$window->add($scrolledwindow);

$window->set_default_size(200, 200);
$window->show_all;

Gtk2->main;

sub make_iconview {
	my $model = Gtk2::ListStore->new('Glib::String', 'Gtk2::Gdk::Pixbuf');
	my $iconview = Gtk2::IconView->new;

	my $col1 = Gtk2::TreeViewColumn->new();
	my $text_renderer = Gtk2::CellRendererText->new;
	$col1->pack_start ($text_renderer, FALSE);
	$col1->add_attribute($text_renderer, text => $TEXT_COLUMN);
	$iconview->set_text_column ($TEXT_COLUMN);
	# $iconview->set_scroll_adjustments(FALSE, FALSE);

	my $col2 = Gtk2::TreeViewColumn->new();
	my $pixbuf_renderer = Gtk2::CellRendererPixbuf->new;
	$col2->pack_start ($pixbuf_renderer, FALSE);
	$col2->add_attribute($pixbuf_renderer, pixbuf => $PIXBUF_COLUMN);
	$iconview->set_pixbuf_column ($PIXBUF_COLUMN);

	$iconview->set_model($model);
	return $iconview;
}

sub add_to_iconview {
	my ($iconview, $name) = @_;
	my $model = $iconview->get_model;
	my $pixbuf = Gtk2::Button->new->render_icon ('gtk-home', 'large-toolbar');
	my $iter = $model->append;
	$model->set($iter, $TEXT_COLUMN, $name, $PIXBUF_COLUMN, $pixbuf);
}
